﻿B4R=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=3.9
@EndOfDesignText@


Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'Public variables can be accessed from all modules.
	
	Dim bc As ByteConverter
	Dim encin(100) As Byte
	Dim decin(100) As Byte
	Dim encout() As Byte
	Dim decout() As Byte

End Sub


Sub Encode(StringToURLEncode As String) As String
	bc.ArrayCopy(StringToURLEncode.GetBytes,  encin)
	RunNative("encurl", Null)
	Log(encout.Length)
	Return bc.StringFromBytes(encout)
End Sub

Sub Decode(StringToURLDecode As String) As String
	bc.ArrayCopy(StringToURLDecode.GetBytes,  decin)
	RunNative("decurl", Null)
	Log(decout.Length)
	Return bc.StringFromBytes(decout)
End Sub


#if c


unsigned char h2int(char c)
{
    if (c >= '0' && c <='9'){
        return((unsigned char)c - '0');
    }
    if (c >= 'a' && c <='f'){
        return((unsigned char)c - 'a' + 10);
    }
    if (c >= 'A' && c <='F'){
        return((unsigned char)c - 'A' + 10);
    }
    return(0);
}

String c_urldecode(String str)
{
    
    String encodedString="";
    char c;
    char code0;
    char code1;
    for (int i =0; i < str.length(); i++){
        c=str.charAt(i);
      if (c == '+'){
        encodedString+=' ';  
      }else if (c == '%') {
        i++;
        code0=str.charAt(i);
        i++;
        code1=str.charAt(i);
        c = (h2int(code0) << 4) | h2int(code1);
        encodedString+=c;
      } else{
        
        encodedString+=c;  
      }
      
      yield();
    }
    
   return encodedString;
}

String c_urlencode(String str)
{
    String encodedString="";
    char c;
    char code0;
    char code1;
    char code2;
    for (int i =0; i < str.length(); i++){
      c=str.charAt(i);
      if (c == ' '){
        encodedString+= '+';
      } else if (isalnum(c)){
        encodedString+=c;
      } else{
        code1=(c & 0xf)+'0';
        if ((c & 0xf) >9){
            code1=(c & 0xf) - 10 + 'A';
        }
        c=(c>>4)&0xf;
        code0=c+'0';
        if (c > 9){
            code0=c - 10 + 'A';
        }
        code2='\0';
        encodedString+='%';
        encodedString+=code0;
        encodedString+=code1;
        //encodedString+=code2;
      }
      yield();
    }
    return encodedString;
    
}



void encurl(B4R::Object* o){
String str = String((byte)b4r_url::_encin->data);
Serial.println(str);
byte b1[1600];
Serial.println("Here");
str = c_urlencode(str);
Serial.println("Here 2");
str.getBytes(b1, str.length());
Serial.println("Here 3");
b4r_url::_encout->data = b1;
b4r_url::_encout->length = str.length();
Serial.println("Here 4");
}


void decurl(B4R::Object* o){
String str = String((byte)b4r_url::_decin->data);
Serial.println(str);
byte b1[1600];
Serial.println("Here");
str = c_urldecode(str);
Serial.println("Here 2");
str.getBytes(b1, str.length());
Serial.println("Here 3");
b4r_url::_decout->data = b1;
b4r_url::_decout->length = str.length();
Serial.println("Here 4");
}

#End If